local GG = {
	Event = {},
	data = {
		playerID = "",
		update = false,
		enable = false,
		firstCall = 0.0,
		meter_x = 0,
		meter_y = 0,
		playerX =0,
		playerY =0,
		playerZ =0,
		button_y = 0,
		button_x = 0,
		PingVer= 194,
		warned = false,
	},
}

local GGPingChannelName = nil
if (shard == "Akala" or shard == "Argent" or shard == "Blightweald" or shard == "Bloodiron" or shard == "Brisesol" or shard == "Brutmutter" or shard == "Brutwacht" or shard == "Icewatch" or shard == "Phynnious" or shard == "Tr\195\188bkopf") then

GGPingChannelName = "GGVERSION@Blightweald"

elseif (shard == "Deepwood" or shard == "Faeblight" or shard == "Greybriar" or shard == "Laethys" or shard == "Seastone" or shard == "Shatterbone" or shard == "Threesprings" or shard == "Wolfsbane") then
GGPingChannelName = "GGVERSION@Wolfsbane"
end



--arrow:SetPoint("CENTER",UI.Native.MapMini, "CENTER", ((math.floor(fx*100)*1.3) +20), ((math.floor(fy*100)*1.3)+20))
local GG_arrow_scale = 1
local GG_arrow_adjust = 20
local GG_chase_scale = 36
local GG_chase_pos = 100

local GGnodes = {}


local function firststamp()

for key, node in pairs(GGnodes) do

local Bias = math.floor(((math.random(30,70))/100) * Inspect.Time.Real())

node.Stamp = Bias;

end
end

local function GGunitAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		GG.data.enable = true
		end 
		end 
		end
		
local function GGunitNotAvailable(handle, units)
	for k, v in pairs(units) do
		if(v == "player") then
		GG.data.enable = false
		end 
		end 
		end
		
function GG.Event.LoadEnd(handle, identifier)
	if identifier == "GravitationalGathering" then
		GG.data.playerID = Inspect.Unit.Lookup("player")
		
		print("GravitationalGathering loaded. /GG")
		if (GGPingChannelName ~= nil) then
		print("/join ".. GGPingChannelName .. " for version updates and news")
		end
	end
end
local last_t = Inspect.Time.Real()

local function AddDragFrame(window)

  function window.Event:LeftDown()
    self.leftDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:LeftUp()
    self.leftDown = false
  end

  function window.Event:LeftUpoutside()
    self.leftDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.leftDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	GG.data.meter_x = x - self.originalXDiff
	GG.data.meter_y = y - self.originalYDiff
  end
end

local function AddDragButton(window)

  function window.Event:RightDown()
    self.rightDown = true
    local mouse = Inspect.Mouse()
    self.originalXDiff = mouse.x - self:GetLeft()
    self.originalYDiff = mouse.y - self:GetTop()
    local left, top, right, bottom = window:GetBounds()
    window:ClearAll()
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", left, top)
    window:SetWidth(right-left)
    window:SetHeight(bottom-top)
  end

  function window.Event:RightUp()
    self.rightDown = false
  end

  function window.Event:RightUpoutside()
    self.rightDown = false
  end

  function window.Event:MouseMove(x, y)
    if not self.rightDown then
      return
    end
    window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", x - self.originalXDiff, y - self.originalYDiff)
	GG.data.button_x = x - self.originalXDiff
	GG.data.button_y = y - self.originalYDiff
  end
end

local main = UI.CreateContext("UI")
local box = UI.CreateFrame("Frame", "box", main)
local ticker = UI.CreateFrame("Text", "Ticker", box)
local arrow = UI.CreateFrame("Texture", "Arrow", main)

local GGIcon = UI.CreateFrame("Texture", "GGIcon", main)

GGIcon:SetWidth(50)
GGIcon:SetHeight(50)
GGIcon:SetLayer(5)
GGIcon:SetTexture("GravitationalGathering", "GGoff.PNG")
GGIcon:SetPoint("TOPLEFT", main, "TOPLEFT", GG.data.button_x, GG.data.button_y)
GGIcon:SetVisible(true)

local AVGticker = UI.CreateFrame("Text", "AVGticker", GGIcon)
AVGticker:SetText("0%")
AVGticker:SetPoint("CENTER",GGIcon,"CENTER",0,35)
AVGticker:SetFontSize(15)
AVGticker:SetVisible(false)
AVGticker:SetLayer(10)
AVGticker:SetBackgroundColor(0,0,0, .4)

arrow:SetWidth(36)
arrow:SetHeight(36)
arrow:SetTexture("GravitationalGathering", "Blue.PNG")
arrow:SetVisible(false)

box:SetPoint("CENTER",UIParent,"CENTER",100,100)
box:SetWidth(250)
box:SetHeight(40)
box:SetAlpha(.6)
box:SetVisible(false)
box:SetBackgroundColor(0,0,0)

ticker:SetText(" 0 : 0 : 0 ")
ticker:SetPoint("CENTER",box,"CENTER",0,0)
ticker:SetFontSize(25)


local lastCall = 0.0;
AddDragButton(GGIcon)

local job_coroutine

local function job(handle)

if GG.data.update and GG.data.enable then

if not lastCall then lastCall = Inspect.Time.Real() end
--local progress = 0
local needtoupdate = false
local fx = 0;				    -- cumulative force, X-component
local fy = 0;				    -- cumulative force, Y-component

GG.data.playerID = Inspect.Unit.Lookup("player")

if(Inspect.Unit.Detail(GG.data.playerID).coordX)then
GG.data.playerX = math.floor(Inspect.Unit.Detail(GG.data.playerID).coordX)
GG.data.playerY = math.floor(Inspect.Unit.Detail(GG.data.playerID).coordY)
GG.data.playerZ = math.floor(Inspect.Unit.Detail(GG.data.playerID).coordZ)
end

local yield = Inspect.Time.Real() + 0.01 

for key, node in pairs(GGnodes) do

if not (node.x or node.y or node.z) then table.remove(GGnodes, key) end
local now = Inspect.Time.Real()
local dx = tonumber(node.x) - GG.data.playerX;
local dy = tonumber(node.y) - GG.data.playerY; --alt
local dz = tonumber(node.z) - GG.data.playerZ;
local rsqrd = (dx * dx) + (dy * dy) + (dz *dz);
local r = math.sqrt(rsqrd); --distance to node 3D
local age = now - node.Stamp; -- time since last inspect

if (r < 45) then

if (age>5)then
--print("Node Checked: "..key)
needtoupdate = true
node.Checked = true
end
--node.Checked = true

node.Stamp = now;
else
local force = age / (r * rsqrd);
fx = fx + force * dx;
fy = fy + force * dz; --conversion back to 2D for minimap tracking y = z from 3d

end

if(Inspect.Time.Real() >= yield) then
--print("yielding")
			coroutine.yield()
			yield = Inspect.Time.Real() + 0.01
		end
end

local gravityScale = math.sqrt(fx * fx + fy * fy)
fx = fx / gravityScale
fy = fy / gravityScale



if needtoupdate then
local progress = 0
for key, node in pairs(GGnodes) do

if (node.Checked == true) then progress = progress+1 end

end
needtoupdate = false
--print(progress)
AVGticker:SetText(tostring(math.floor(progress / table.getn(GGnodes)*100)).."%")
end
--print(progress)

arrow:SetPoint("CENTER",UI.Native.MapMini, "CENTER", ((math.floor(fx*100)*GG_arrow_scale) +GG_arrow_adjust), ((math.floor(fy*100)*GG_arrow_scale)+GG_arrow_adjust))
end

lastCall = now
end



local mining_options_frames = {}
local herbing_options_frames = {}
local wooding_options_frames = {}
local art_options_frames = {}
local fish_options_frames = {}
local scale_options_frames = {}
local route_options_frames = {}

--local OmegaImport = {}
local Omega =
{

["Tin Lode"] = true,

["Copper Vein"] = true,

["Iron Vein"] = true,

["Silver Vein"] = true,

["Chromite Vein"] = true,

["Cobalt Lode"] = true,

["Gold Vein"] = true,

["Titanium Vein"] = true,

["Carmintium Deposit"] = true,

["Platinum Deposit"] = true,

["Orichalcum"] = true,

["Gantimite Vein"] = true,

["Karthite Vein"] = true,

["Rhenium Vein"] = true,

--gems
["Tin Lode Gem"] = 0,

["Copper Vein Gem"] = 0,

["Iron Vein Gem"] = 0,

["Silver Vein Gem"] = 0,

["Chromite Vein Gem"] = 0,

["Cobalt Lode Gem"] = 0,

["Gold Vein Gem"] = 0,

["Titanium Vein Gem"] = 0,

["Carmintium Deposit Gem"] = 0,

["Platinum Deposit Gem"] = 0,

["Orichalcum Gem"] = 0,

["Gantimite Vein Gem"] = 0,

["Karthite Vein Gem"] = 0,

["Rhenium Vein Gem"] = 0,

--herbs
["Coastal Glory"] = true,

["Grieveblossom"] = true,

["Bloodbriar"] = true,

["Corpseblossom"] = true,

["Creeperbrush"] = true,

["Razorbrush"] = true,

["Krakenweed"] = true,

["Golden Nettle"] = true,

["Duskglory"] = true,

["Wyvernspurr"] = true,

["Tattertwist"] = true,

["Roc Orchid"] = true,

["Drakefoot"] = true,

["Bloodshade"] = true,

["Basiliskweed"] = true,

["Tempestflower"] = true,

["Twilight Bloom"] = true,

["Chimera's Cloak"] = true,

["Frazzleweed"] = true,

["Lucidflower"] = true,

--wood
["Yew Log"] = true,

["Ashwood Log"] = true,

["Oak Log"] = true,

["Mahogany Log"] = true,

["Kingswood Log"] = true,

["Runebirch Log"] = true,

["Sagebrush Log"] = true,

["Shadethorn Branch"] = true,

["Linden Timber"] = true,

["Elm Timber"] = true,

["Madrosa Timber"] = true,

-- fish 
["School of Fish"] = true,
["School of Clever Fish"] = true,
["School of Rare Fish"] = true,
["Sunken Boat"] = true,

}




local function abort_job()
	job_coroutine = nil
end

local function run_job(handle)
	if(job_coroutine) then
		if(coroutine.status(job_coroutine) == "dead") then
			--print("dead")
			abort_job()
			
		else
		if(coroutine.status(job_coroutine) == "suspended") then
			--print("assert")
			--assert(coroutine.resume(job_coroutine))
			coroutine.resume(job_coroutine)
			end
		end
		
		else job_coroutine = coroutine.create(job)
	end
end
local function start_job()
	--print ("start")
	job_coroutine = coroutine.create(job)
end

local function createroute()
GG.data.enable = false
GG.data.update = false
local trackedcount = 0
GGnodes={}
local currentzone = Inspect.Zone.Detail(Inspect.Unit.Detail("player").zone).name

for zone, record in pairs(GlobalMapData) do

if zone == currentzone then

for mat, list in pairs (record) do
--print(mat)
if Omega[mat] ~= nil then

if (Omega[mat] == true ) then
print("Loading " .. mat.." data")
for i, c in ipairs(list) do

table.insert(GGnodes, {x = c[1], y = c[2], z= c[3], Stamp = 200,Checked = false})
trackedcount = trackedcount + 1
end
else 
if (Omega[mat .." Gem"] ~= nil) then
if (Omega[mat .." Gem"] > 0) then
print("Loading " .. mat.." data")
for i, c in ipairs(list) do

table.insert(GGnodes, {x = c[1], y = c[2], z= c[3], Stamp = 200,})
trackedcount = trackedcount + 1

end
end
end
end
end

end
end
end

if trackedcount == 0 then 
print("No Nodes Match Filters: Tracking Terminated") 
arrow:SetVisible(false) 
--return 
else 
print(trackedcount .." Nodes Registered - Follow the red X.") 
arrow:SetVisible(true) 
end
GG.data.enable = true
GG.data.update = true
end

local config_context = UI.CreateContext("config_context")
local config_main_back = UI.CreateFrame("RiftWindow", "config_main_back", config_context)

config_main_back:SetLayer(3)
config_main_back:SetHeight(800)
config_main_back:SetWidth(600)
config_main_back:SetVisible(false)
config_main_back:SetPoint("TOPLEFT", UIParent, "TOPCENTER", 0,0)
config_main_back:SetTitle("Gravitational Gathering")

local config_close_button = UI.CreateFrame("RiftButton", "config_close_button", config_main_back)
config_close_button:SetLayer(10)
config_close_button:SetHeight(70)
config_close_button:SetWidth(150)
config_close_button:SetVisible(false)
config_close_button:SetPoint("BOTTOMLEFT", config_main_back, "BOTTOMLEFT", 15,0)
config_close_button:SetText("Apply Filters")
config_close_button:SetAlpha(.7)

local config_ALL_button = UI.CreateFrame("RiftButton", "config_ALL_button", config_main_back)
config_ALL_button:SetLayer(10)
config_ALL_button:SetHeight(70)
config_ALL_button:SetWidth(150)
config_ALL_button:SetVisible(false)
config_ALL_button:SetPoint("BOTTOMLEFT", config_main_back, "BOTTOMLEFT", 155,0)
config_ALL_button:SetText("Select All")
config_ALL_button:SetAlpha(.7)

local config_NONE_button = UI.CreateFrame("RiftButton", "config_NONE_button", config_main_back)
config_NONE_button:SetLayer(10)
config_NONE_button:SetHeight(70)
config_NONE_button:SetWidth(150)
config_NONE_button:SetVisible(false)
config_NONE_button:SetPoint("BOTTOMLEFT", config_main_back, "BOTTOMLEFT", 295,0)
config_NONE_button:SetText("Deselect All")
config_NONE_button:SetAlpha(.7)

local config_Cancel_button = UI.CreateFrame("RiftButton", "config_Cancel_button", config_main_back)
config_Cancel_button:SetLayer(10)
config_Cancel_button:SetHeight(70)
config_Cancel_button:SetWidth(150)
config_Cancel_button:SetVisible(false)
config_Cancel_button:SetPoint("BOTTOMLEFT", config_main_back, "BOTTOMLEFT", 435,0)
config_Cancel_button:SetText("Cancel")
config_Cancel_button:SetAlpha(.7)





local config_inlay_left = UI.CreateFrame("Frame", "config_inlay", config_main_back)
--config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-140, 65)
config_inlay_left:SetBackgroundColor(0,0,0,.6)
--config_inlay_left:SetHeight(500)
--config_inlay_left:SetWidth(255)
config_inlay_left:SetLayer(4)
config_inlay_left:SetVisible(false)



local config_inlay_right = UI.CreateFrame("Frame", "config_inlay", config_main_back)
--config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",135, 65)
config_inlay_right:SetBackgroundColor(0,0,0,.6)
--config_inlay_right:SetHeight(675)
--config_inlay_right:SetWidth(255)
config_inlay_right:SetLayer(4)
config_inlay_right:SetVisible(false)

local config_main_tabs = UI.CreateFrame("Texture", "config_main_tabs", config_context)

config_main_tabs:SetLayer(1)
config_main_tabs:SetHeight(280)
config_main_tabs:SetWidth(110)
config_main_tabs:SetVisible(false)
config_main_tabs:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -95,75)
config_main_tabs:SetTexture("GravitationalGathering","tabs_back.png")
--metal

local metaltab = UI.CreateFrame("Texture", ("metaltabtexture"), config_context)

metaltab:SetLayer(2)
metaltab:SetHeight(45)
metaltab:SetWidth(100)
metaltab:SetVisible(false)
metaltab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,80)
metaltab:SetTexture("GravitationalGathering","tabs_back.png")
metaltab:SetAlpha(.7)

local metaltab_text = UI.CreateFrame("Text", ("metaltab_text"), metaltab)
metaltab_text:SetHeight(22)
metaltab_text:SetWidth(100)
metaltab_text:SetLayer(3)
metaltab_text:SetVisible(true)
metaltab_text:SetFontSize(19)
metaltab_text:SetText("Mining")
metaltab_text:SetPoint("TOPLEFT",metaltab,"TOPLEFT",15,10)
metaltab_text:SetAlpha(1)


local herbstab = UI.CreateFrame("Texture", ("herbstabtexture"), config_context)
herbstab:SetLayer(2)
herbstab:SetHeight(45)
herbstab:SetWidth(100)
herbstab:SetVisible(false)
herbstab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,125)
herbstab:SetTexture("GravitationalGathering","tabs_back.png")
herbstab:SetAlpha(.7)

local herbstab_text = UI.CreateFrame("Text", ("herbstab_text"), herbstab)
herbstab_text:SetHeight(22)
herbstab_text:SetWidth(100)
herbstab_text:SetLayer(3)
herbstab_text:SetVisible(true)
herbstab_text:SetFontSize(19)
herbstab_text:SetText("Foraging")
herbstab_text:SetPoint("TOPLEFT",herbstab,"TOPLEFT",15,10)
herbstab_text:SetAlpha(1)


--art
local arttab = UI.CreateFrame("Texture", ("arttabtexture"), config_context)
arttab:SetLayer(2)
arttab:SetHeight(45)
arttab:SetWidth(100)
arttab:SetVisible(false)
arttab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,170)
arttab:SetTexture("GravitationalGathering","tabs_back.png")
arttab:SetAlpha(.7)

local arttab_text = UI.CreateFrame("Text", ("arttab_text"), arttab)
arttab_text:SetHeight(22)
arttab_text:SetWidth(100)
arttab_text:SetLayer(3)
arttab_text:SetVisible(true)
arttab_text:SetFontSize(19)
arttab_text:SetText("Artifacts")
arttab_text:SetPoint("TOPLEFT",arttab,"TOPLEFT",15,10)
arttab_text:SetAlpha(1)



--fish
local fishtab = UI.CreateFrame("Texture", ("fishtabtexture"), config_context)
fishtab:SetLayer(2)
fishtab:SetHeight(45)
fishtab:SetWidth(100)
fishtab:SetVisible(false)
fishtab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,215)
fishtab:SetTexture("GravitationalGathering","tabs_back.png")
fishtab:SetAlpha(.7)

local fishtab_text = UI.CreateFrame("Text", ("fishtab_text"), fishtab)
fishtab_text:SetHeight(22)
fishtab_text:SetWidth(100)
fishtab_text:SetLayer(3)
fishtab_text:SetVisible(true)
fishtab_text:SetFontSize(19)
fishtab_text:SetText("Fishing")
fishtab_text:SetPoint("TOPLEFT",fishtab,"TOPLEFT",15,10)
fishtab_text:SetAlpha(1)

--scale
local scaletab = UI.CreateFrame("Texture", ("scaletabtexture"), config_context)
scaletab:SetLayer(2)
scaletab:SetHeight(45)
scaletab:SetWidth(100)
scaletab:SetVisible(false)
scaletab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,260)
scaletab:SetTexture("GravitationalGathering","tabs_back.png")
scaletab:SetAlpha(.7)

local scaletab_text = UI.CreateFrame("Text", ("scaletab_text"), scaletab)
scaletab_text:SetHeight(22)
scaletab_text:SetWidth(100)
scaletab_text:SetLayer(3)
scaletab_text:SetVisible(true)
scaletab_text:SetFontSize(19)
scaletab_text:SetText("UI Scale")
scaletab_text:SetPoint("TOPLEFT",scaletab,"TOPLEFT",15,10)
scaletab_text:SetAlpha(1)

--general
local routetab = UI.CreateFrame("Texture", ("routetabtexture"), config_context)
routetab:SetLayer(2)
routetab:SetHeight(45)
routetab:SetWidth(100)
routetab:SetVisible(false)
routetab:SetPoint("TOPLEFT", config_main_back, "TOPLEFT", -90,305)
routetab:SetTexture("GravitationalGathering","tabs_back.png")
routetab:SetAlpha(.7)

local routetab_text = UI.CreateFrame("Text", ("routetab_text"), routetab)
routetab_text:SetHeight(22)
routetab_text:SetWidth(100)
routetab_text:SetLayer(3)
routetab_text:SetVisible(true)
routetab_text:SetFontSize(19)
routetab_text:SetText("Route")
routetab_text:SetPoint("TOPLEFT",routetab,"TOPLEFT",15,10)
routetab_text:SetAlpha(1)

local currentTab = ""

local function ShowHerbOptions()
currentTab = "Herb"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(true)

config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-5, 65)
config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-5, 485)

config_inlay_left:SetHeight(395)
config_inlay_left:SetWidth(525)

config_inlay_right:SetHeight(220)
config_inlay_right:SetWidth(525)

config_ALL_button:SetEnabled(true)
config_NONE_button:SetEnabled(true)

for key, frame in pairs (herbing_options_frames) do
frame:SetVisible(true)
end
for key, frame in pairs (wooding_options_frames) do
frame:SetVisible(true)
end
end

local function HideHerbOptions()
for key, frame in pairs (herbing_options_frames) do
frame:SetVisible(false)
end
for key, frame in pairs (wooding_options_frames) do
frame:SetVisible(false)
end
end

local function ShowMiningOptions()
currentTab = "Mining"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(true)
config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-140, 65)
config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",135, 65)

config_inlay_left:SetHeight(500)
config_inlay_left:SetWidth(255)

config_inlay_right:SetHeight(675)
config_inlay_right:SetWidth(255)

config_ALL_button:SetEnabled(true)
config_NONE_button:SetEnabled(true)

for key, frame in pairs (mining_options_frames) do
frame:SetVisible(true)
end
end

local function HideMiningOptions()
for key, frame in pairs (mining_options_frames) do
frame:SetVisible(false)
end
end
-- show hide art
local function ShowArtOptions()
currentTab = "Art"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(false)

config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-140, 65)
config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",135, 65)

config_inlay_left:SetHeight(115)
config_inlay_left:SetWidth(255)

config_inlay_right:SetHeight(675)
config_inlay_right:SetWidth(255)

config_ALL_button:SetEnabled(true)
config_NONE_button:SetEnabled(true)

for key, frame in pairs (art_options_frames) do
frame:SetVisible(true)
end
end

local function HideArtOptions()
for key, frame in pairs (art_options_frames) do
frame:SetVisible(false)
end
end

-- show hide fish
local function ShowFishOptions()
currentTab = "Fish"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(false)

config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-140, 65)
config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",135, 65)

config_inlay_left:SetHeight(145)
config_inlay_left:SetWidth(255)

config_inlay_right:SetHeight(675)
config_inlay_right:SetWidth(255)

config_ALL_button:SetEnabled(true)
config_NONE_button:SetEnabled(true)

for key, frame in pairs (fish_options_frames) do
frame:SetVisible(true)
end
end

local function HideFishOptions()
for key, frame in pairs (fish_options_frames) do
frame:SetVisible(false)
end
end

--show hide route
local function ShowRouteOptions()
currentTab = "Route"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(false)

config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",-140, 65)
config_inlay_right:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",135, 65)

config_inlay_left:SetHeight(465)
config_inlay_left:SetWidth(255)

config_inlay_right:SetHeight(675)
config_inlay_right:SetWidth(255)

config_ALL_button:SetEnabled(true)
config_NONE_button:SetEnabled(true)

for key, frame in pairs (route_options_frames) do
frame:SetVisible(true)
end
end

local function HideRouteOptions()
for key, frame in pairs (route_options_frames) do
frame:SetVisible(false)
end
end

--show hide scale
local function ShowScaleOptions()
currentTab = "Scale"
config_inlay_left:SetVisible(true)
config_inlay_right:SetVisible(false)

config_inlay_left:SetPoint("TOPCENTER",config_main_back,"TOPCENTER",0, 150)


config_inlay_left:SetHeight(200)
config_inlay_left:SetWidth(520)

config_ALL_button:SetEnabled(false)
config_NONE_button:SetEnabled(false)

for key, frame in pairs (scale_options_frames) do
frame:SetVisible(true)
end
end

local function HideScaleOptions()
for key, frame in pairs (scale_options_frames) do
frame:SetVisible(false)
end
end



local function ShowMainOptions()
config_main_back:SetVisible(true)
config_main_tabs:SetVisible(true)
arttab:SetVisible(true)
metaltab:SetVisible(true)
herbstab:SetVisible(true)
fishtab:SetVisible(true)
scaletab:SetVisible(true)
routetab:SetVisible(true)
config_close_button:SetVisible(true)
config_ALL_button:SetVisible(true)
config_NONE_button:SetVisible(true)
config_Cancel_button:SetVisible(true)
config_inlay_right:SetVisible(true)
config_inlay_left:SetVisible(true)
HideHerbOptions()
HideArtOptions()
HideFishOptions()
HideRouteOptions()
HideScaleOptions()
ShowMiningOptions()

end

local function HideMainOptions()
config_main_back:SetVisible(false)
config_main_tabs:SetVisible(false)
arttab:SetVisible(false)
metaltab:SetVisible(false)
herbstab:SetVisible(false)
fishtab:SetVisible(false)
scaletab:SetVisible(false)
routetab:SetVisible(false)
config_close_button:SetVisible(false)
config_ALL_button:SetVisible(false)
config_NONE_button:SetVisible(false)
config_Cancel_button:SetVisible(false)
config_inlay_right:SetVisible(false)
config_inlay_left:SetVisible(false)

end

local IconedOptions = false

function config_close_button.Event:LeftPress()
if (IconedOptions) then
IconedOptions = not IconedOptions
end
	GGIcon:SetTexture("GravitationalGathering", "GG.PNG")
	AVGticker:SetVisible(true)
	HideMainOptions()
 	createroute()
	firststamp()
end

function selectALL(frames)
for key, frame in pairs (frames) do
if frame:GetType() == "RiftCheckbox" then
frame:SetChecked(true)
end
end
end
function deselectALL(frames)
for key, frame in pairs (frames) do
if frame:GetType() == "RiftCheckbox" then
frame:SetChecked(false)
end
end
end

--[[
local mining_options_frames = {}
local herbing_options_frames = {}
local wooding_options_frames = {}
local art_options_frames = {}
local fish_options_frames = {}
local craft_options_frames = {}
local route_options_frames = {}

--]]

function config_ALL_button.Event:LeftPress() 

if currentTab == "Herb" then 
selectALL(herbing_options_frames) 
selectALL(wooding_options_frames)
end

if currentTab == "Mining" then 
selectALL(mining_options_frames) 

--gems
Omega["Tin Lode Gem"] = 2

Omega["Copper Vein Gem"] = 2

Omega["Iron Vein Gem"] = 2

Omega["Silver Vein Gem"] = 4

Omega["Chromite Vein Gem"] = 2

Omega["Cobalt Lode Gem"] = 2

Omega["Gold Vein Gem"] = 4

Omega["Titanium Vein Gem"] = 2

Omega["Carmintium Deposit Gem"] = 2

Omega["Platinum Deposit Gem"] = 4

Omega["Orichalcum Gem"] = 2

Omega["Gantimite Vein Gem"] = 2

Omega["Karthite Vein Gem"] = 2

Omega["Rhenium Vein Gem"] = 3
end

if currentTab == "Art" then 
--selectALL(art_options_frames) 
end

if currentTab == "Fish" then selectALL(fish_options_frames) end


if currentTab == "Route" then  end

end

function config_NONE_button.Event:LeftPress()
 if currentTab == "Herb" then 
deselectALL(herbing_options_frames) 
deselectALL(wooding_options_frames)
end

if currentTab == "Mining" then 
deselectALL(mining_options_frames) 

--gems
Omega["Tin Lode Gem"] = 0

Omega["Copper Vein Gem"] = 0

Omega["Iron Vein Gem"] = 0

Omega["Silver Vein Gem"] = 0

Omega["Chromite Vein Gem"] = 0

Omega["Cobalt Lode Gem"] = 0

Omega["Gold Vein Gem"] = 0

Omega["Titanium Vein Gem"] = 0

Omega["Carmintium Deposit Gem"] = 0

Omega["Platinum Deposit Gem"] = 0

Omega["Orichalcum Gem"] = 0

Omega["Gantimite Vein Gem"] = 0

Omega["Karthite Vein Gem"] = 0

Omega["Rhenium Vein Gem"] = 0

end

if currentTab == "Art" then 
--deselectALL(art_options_frames) 
end

if currentTab == "Fish" then deselectALL(fish_options_frames) end


if currentTab == "Route" then  end
end

function config_Cancel_button.Event:LeftPress() 
if (IconedOptions) then
IconedOptions = not IconedOptions
end
HideMainOptions()
end





function GGIcon.Event:LeftClick()
 if (IconedOptions) then
 	GGIcon:SetTexture("GravitationalGathering", "GG.PNG")
	AVGticker:SetVisible(true)
		HideMainOptions()
 		createroute()
		firststamp()
 IconedOptions = not IconedOptions
 else
 ShowMainOptions()
 IconedOptions = not IconedOptions
 end
end

function metaltab.Event:LeftClick()
HideHerbOptions()
HideArtOptions()
HideFishOptions()
HideRouteOptions()
HideScaleOptions()
ShowMiningOptions()
end

function herbstab.Event:LeftClick()
HideMiningOptions()
HideArtOptions()
HideFishOptions()
HideRouteOptions()
HideScaleOptions()
ShowHerbOptions()
end

function arttab.Event:LeftClick()
HideMiningOptions()
HideHerbOptions()
HideFishOptions()
HideRouteOptions()
HideScaleOptions()
ShowArtOptions()
end

function fishtab.Event:LeftClick()
HideMiningOptions()
HideHerbOptions()
HideArtOptions()
HideRouteOptions()
HideScaleOptions()
ShowFishOptions()
end

function scaletab.Event:LeftClick()
HideMiningOptions()
HideHerbOptions()
HideArtOptions()
HideFishOptions()
HideRouteOptions()
ShowScaleOptions()

end

function routetab.Event:LeftClick()
HideMiningOptions()
HideHerbOptions()
HideArtOptions()
HideFishOptions()
HideScaleOptions()
ShowRouteOptions()
end




local mining_list = {
--tin
{
node = "Tin Lode",
skillstart = 1, 
ore = "Tin Ore",
Lootables ={Fieldstone},
gems = {"Moonstone", "Sunstone",},
zones = {"Freemarch" , "Silverwood"},
},
--copper
{
node = "Copper Vein",
skillstart = 35 , 
ore = "Copper Ore",
Lootables ={"Opal",},
gems = {"Shimmering Opal","Abyssal Opal"},
zones = {"Freemarch", "Silverwood", "Stonefield", "Gloamwood"},
},
--iron
{
node = "Iron Vein",
skillstart = 75, 
ore = "Iron Ore",
Lootables ={"Geode",},
gems = {"Celestite", "Heartstone"},
zones = {"Stonefield", "Gloamwood", "Scarlet Gorge"},
},
--silver
{
node = "Silver Vein",
skillstart = 80 , 
ore = "Silver Ore",
Lootables ={"Geode","Beryl"},
gems = {"Celestite","Heartstone","Blood Berylite","Radiant Emerald"},
zones = {"Stonefields", "Gloamwood", "Scarlet Gorge", "Scarwood Reach"},
},
--chromite
{
node = "Chromite Vein",
skillstart = 115, 
ore = "Chromite Ore",
Lootables ={"Beryl"},
gems = {"Blood Berylite","Radiant Emerald"},
zones = {"Scarlet Gorge", "Scarwood Reach"},
},
--cobalt
{
node = "Cobalt Lode",
skillstart = 145, 
ore = "Cobalt Ore",
Lootables ={"Agate"},
gems = {"Valeglass Agate","Skystone Agate"},
zones = {"Scarwood Reach", "Droughtlands", "Moonshade Highlands"},
},
--Gold
{
node = "Gold Vein",
skillstart = 150, 
ore = "Gold Ore",
Lootables ={"Agate","Corundum"},
gems = {"Valeglass Agate","Skystone Agate","Sapphire","Ruby"},
zones = {"Scarwood Reach", "Shimmersand", "Droughtlands"},
},
--titanium
{
node = "Titanium Vein",
skillstart = 185 , 
ore = "Titanium Ore",
Lootables ={"Corundum",},
gems = {"Sapphire","Ruby"},
zones = {"Stillmoor", "Shimmersand", "Droughtlands", "Iron Pine Peak", "Moonshade Highlands"},
},
--carmintium
{
node = "Carmintium Deposit",
skillstart = 225, 
ore = "Carmintium Ore",
Lootables ={"Diamond",},
gems = {"Brilliant Diamond","Lightsbane Diamond"},
zones = {"Iron Pine Peak", "Stillmoor", "Shimmersand", "Charmer's Caldera", "Abyssal Precipice", "Ember Isle"},
},
--platinum
{
node = "Platinum Deposit",
skillstart = 230, 
ore = "Platinum Ore",
Lootables ={"Diamond","Lightspar Agate"},
gems = {"Brilliant Diamond","Lightsbane Diamond","Smooth Lightstone","Jagged Lightstone"},
zones = {"Iron Pine Peak", "Stillmoor", "Shimmersand", "Charmer's Caldera", "Abyssal Precipice", "Ember Isle"},
},
--orichalcum
{
node = "Orichalcum",
skillstart = 250, 
ore = "Orichalcum Ore",
Lootables ={"Lightspar Agate",},
gems = {"Smooth Lightstone","Jagged Lightstone"},
zones = {"Iron Pine Peak", "Stillmoor", "Shimmersand", "Charmer's Caldera", "Abyssal Precipice", "Ember Isle"},
},
--gantimite
{
node = "Gantimite Vein",
skillstart = 290, 
ore = "Gantimite Ore",
Lootables ={"Marlistone"},
gems = {"Sphalerite","Tourmaline"},
zones = {"Brevane", "Dusken", "Cape Jule", "Kingdom of Pelladane"},
},
--karthite 
{
node = "Karthite Vein",
skillstart = 335, 
ore = "Karthite Ore",
Lootables ={"Marlistone",},
gems = {"Sphalerite","Tourmaline"},
zones = {"Brevane", "Dusken", "Ardent Domain", "City Core", "Eastern Holdings", "Seratos"},
},
--rhenium
{
node = "Rhenium Vein",
skillstart = 375, 
ore = "Rhenium Ore",
Lootables ={"Rich Marlistone"},
gems = {"Sphalerite", "Tourmaline", "Chrysoprase"},
zones = {"Brevane", "Dusken", "Kingsward", "Ashora", "Morban", "Steppes of Infinity"},
},
} -- end mining list

local herbing_list={
--Coastal Glory
{
node = "Coastal Glory",
herb = "Coastal Glory",
skillstart = 1,
zones =  {"Freemarch", "Silverwood"},
},
--Grieveblossom
{
node = "Grieveblossom",
herb = "Grieveblossom Petals",
skillstart = 1,
zones =  {"Freemarch", "Silverwood"},
},
--Bloodbriar
{
node = "Bloodbriar",
herb = "Bloodbriar Stems",
skillstart = 1,
zones =  {"Stonefield"},
},
--Corpseblossom
{
node = "Corpseblossom",
herb = "Corpseblossom Petals",
skillstart = 1,
zones =  {"Moonshade Highlands"},
},
--Creeperbrush
{
node = "Creeperbrush",
herb = "Creeperbrush Roots",
skillstart = 30,
zones =  {"Freemarch", "Stonefield"},
},
--Razorbrush
{
node = "Razorbrush",
herb = "Razorbrush Leaves",
skillstart = 70,
zones =  {"Stonefield", "Scarlet Gorge"},
},
--Krakenweed
{
node = "Krakenweed",
herb = "Krakenweed Stems",
skillstart = 70,
zones =  {"Stonefield", "Scarlet Gorge"},
},
--Golden Nettle
{
node = "Golden Nettle",
herb = "Evergreen Nettle Stems",
skillstart = 80,
zones =  {"Stonefield", "Scarlet Gorge", "Scarwood Reach"},
},
--Golden Nettle2
{
node = "Golden Nettle",
herb = "Golden Nettle Stems",
skillstart = 80,
zones =  {"Stonefield", "Scarlet Gorge", "Scarwood Reach"},
},
--Duskglory
{
node = "Duskglory",
herb = "Duskglory Petals",
skillstart = 80,
zones =  {"Stonefield", "Scarlet Gorge", "Scarwood Reach"},
},
--Wyvernspurr
{
node = "Wyvernspurr",
herb = "Wyvernspurr Stems",
skillstart = 115,
zones =  {"Scarlet Gorge", "Scarwood Reach", "Droughtlands"},
},
--Tattertwist
{
node = "Tattertwist",
herb = "Tattertwist Leaves",
skillstart = 140,	 
zones =  {"Scarwood Reach", "Moonshade Highlands"},
},
--Roc Orchid
{
node = "Roc Orchid",
herb = "Roc Orchid Petals",
skillstart = 145, 	 
zones =  {"Stillmoor", "Scarwood Rach", "Droughtlands", "Moonshade Highlands", "Iron Pine Peak", "Shimmersand"},
},
--Drakefoot
{
node = "Drakefoot",
herb = "Drakefoot Stems",
skillstart = 180, 
zones =  {"Shimmersand", "Droughtlands", "Iron Pine Peak"},
},
--Drakefoot2
{
node = "Drakefoot",
herb = "Drakefoot Seed",
skillstart = 180,
zones =  {"Shimmersand", "Droughtlands", "Iron Pine Peak"},
},
--Bloodshade
{
node = "Bloodshade",
herb = "Bloodshade Petals",
skillstart = 200,
zones =  {"Stillmoor", "Iron Pine Peak", "Shimmersand"},
},
--Basiliskweed
{
node = "Basiliskweed",
herb = "Basiliskweed Stems",
skillstart = 225,
zones =  {"Stillmoor", "Shimmersand", "Droughtlands"},
},
--Tempestflower
{
node = "Tempestflower",
herb = "Tempestflower Stems",
skillstart = 230,
zones =  {"Stillmoor", "Shimmersand", "Ember Isle"},
},
--Twilight Bloom
{
node = "Twilight Bloom",
herb = "Twilight Bloom Roots",
skillstart = 250,
zones =  {"Iron Pine Peak", "Charmer's Caldera", "Abyssal Precipice", "Stillmoor", "Ember Isle"},
},
--Chimera's Cloak
{
node = "Chimera's Cloak",
herb = "Chimera's Cloak Petals",
skillstart = 290,
zones =  {"Brevane", "Dusken", "Cape Jule", "Kingdom of Pelladane"},
},
--Frazzleweed
{
node = "Frazzleweed",
herb = "Frazzleweed Tuft",
skillstart = 335,
zones =  {"Brevane", "Dusken" , "Ardent Domain", "City Core", "Eastern Holdings", "Seratos"},
},
--Lucidflower
{
node = "Lucidflower",
herb = "Lucidflower Spire",
skillstart = 375,
zones =  {"Brevane" ,  "Dusken", "Kingsward", "Ashora", "Morban", "Steppes of Infinity"},
},

}--end herbing list

local wooding_list={

{skillstart = 1,	node = 	"Yew Log",				wood = "Yew Timber",		zones =  {"Freemarch", "Silverwood"},},
{skillstart = 35,	node =  "Ashwood Log",			wood = "Ashwood Timber", 	zones =  {"Freemarch", "Stonefield"},},
{skillstart = 75,	node =  "Oak Log",				wood = "Oak Log", 			zones =  {"Stonefield", "Scarlet Gorge"},},
{skillstart = 115,	node =  "Mahogany Log",			wood = "Mahogany Log",		zones =  {"Scarlet Gorge", "Scarwood Reach", "Stonefield", "Droughtlands"},},
{skillstart = 145,	node =  "Kingswood Log",		wood = "Kingswood Log", 	zones =  {"Shimmersand", "Scarwood Reach", "Droughtlands", "Moonshade Highlands"},},
{skillstart = 185,	node =  "Runebirch Log",		wood = "Runebirch Log",		zones =  {"Moonshade Highlands", "Iron Pine Peak", "Stillmoor"},},
{skillstart = 225,	node =  "Sagebrush Log",		wood = "Sagebrush Timber",	zones =  {"Iron Pine Peak", "Stillmoor", "Shimmersand", "Ember Isle"},},
{skillstart = 250,	node =  "Shadethorn Branch",	wood = "Shadethorn Log",	zones =  {"Iron Pine Peak", "Charmer's Caldera", "Abyssal Precipice", "Stillmoor", "Ember Isle"},},
{skillstart = 290,	node =  "Linden Timber", 		wood = "Linden Timber",		zones =  {"Brevane", "Dusken", "Cape Jule", "Kingdom of Pelladane"},},
{skillstart = 335,	node =  "Elm Timber",			wood = "Elm Timber",		zones =  {"Brevane", "Dusken", "Ardent Domain", "City Core", "Eastern Holdings", "Seratos"},},
{skillstart = 375,	node =  "Madrosa Timber",		wood = "Madrosa Timber",	zones =  {"Brevane", "Dusken", "Kingsward", "Ashora", "Morban", "Steppes of Infinity"},},

}--end wooding list

local fishing_list =
{
{ node = "School of Fish"},
{ node = "School of Clever Fish"},
{ node = "School of Rare Fish"},
{ node = "Sunken Boat"},
}
local artifact_list =
{
{node = "Find Normal"},
{node = "Find Twisted"},
{node = "Sight Warning"}, 
}

local route_list = 
{
{node = "Mountain Climb"},
{node = "Small Hill Climb"},
{node = "Flat ground"}, 
{node = "Shallow Water"},
{node = "Deep Water"},
{node = "Inside Buildings"},
{node = "Small Cave"},
{node = "Big Cave"},
{node = "Obstacle to Reach"},
{node = "Elite Mob Areas"},
{node = "Guardian Areas"},
{node = "Defiance Areas"},
{node = "Zone Lock"},
}

local function gemmREMOVE(gemm)

--tin
if (gemm == "Sunstone") or (gemm == "Moonstone") then

Omega["Tin Lode Gem"] = Omega["Tin Lode Gem"] - 1

if Omega["Tin Lode Gem"] < 0 then Omega["Tin Lode Gem"] = 0 end
end

--copper
if (gemm == "Shimmering Opal") or (gemm =="Abyssal Opal") then
Omega["Copper Vein Gem"] = Omega["Copper Vein Gem"] - 1
if Omega["Copper Vein Gem"] < 0 then Omega["Copper Vein Gem"] = 0 end
end

--iron
if (gemm == "Celestite") or (gemm == "Heartstone") then
Omega["Iron Vein Gem"] = Omega["Iron Vein Gem"] - 1
if Omega["Iron Vein Gem"] < 0 then Omega["Iron Vein Gem"] = 0 end
end

--silver
if (gemm == "Celestite") or (gemm == "Heartstone") or (gemm == "Blood Berylite") or (gemm == "Radiant Emerald") then
Omega["Silver Vein Gem"] = Omega["Silver Vein Gem"] - 1
if Omega["Silver Vein Gem"] < 0 then Omega["Silver Vein Gem"] = 0 end
end

--chromite
if (gemm == "Blood Berylite") or (gemm =="Radiant Emerald") then
Omega["Chromite Vein Gem"] = Omega["Chromite Vein Gem"] - 1
if Omega["Chromite Vein Gem"] < 0 then Omega["Chromite Vein Gem"] = 0 end
end

--cobalt
if (gemm == "Valeglass Agate") or (gemm == "Skystone Agate") then
Omega["Cobalt Lode Gem"] = Omega["Cobalt Lode Gem"] - 1
if Omega["Cobalt Lode Gem"] < 0 then Omega["Cobalt Lode Gem"] = 0 end
end

--Gold
if (gemm == "Valeglass Agate") or (gemm == "Skystone Agate") or (gemm == "Sapphire") or (gemm == "Ruby") then
Omega["Gold Vein Gem"] = Omega["Gold Vein Gem"] - 1
if Omega["Gold Vein Gem"] < 0 then Omega["Gold Vein Gem"] = 0 end
end

--titanium
if (gemm == "Sapphire") or (gemm == "Ruby") then
Omega["Titanium Vein Gem"] = Omega["Titanium Vein Gem"] - 1
if Omega["Titanium Vein Gem"] < 0 then Omega["Titanium Vein Gem"] = 0 end
end

--carmintium
if (gemm == "Brilliant Diamond") or (gemm == "Lightsbane Diamond") then
Omega["Carmintium Deposit Gem"] = Omega["Carmintium Deposit Gem"] - 1
if Omega["Carmintium Deposit Gem"] < 0 then Omega["Carmintium Deposit Gem"] = 0 end
end

--platinum
if (gemm == "Brilliant Diamond") or (gemm == "Lightsbane Diamond") or (gemm == "Smooth Lightstone") or (gemm == "Jagged Lightstone") then
Omega["Platinum Deposit Gem"] = Omega["Platinum Deposit Gem"] - 1
if Omega["Platinum Deposit Gem"] < 0 then Omega["Platinum Deposit Gem"] = 0 end
end

--orichalcum
if (gemm == "Smooth Lightstone") or (gemm == "Jagged Lightstone") then
Omega["Orichalcum Gem"] = Omega["Orichalcum Gem"] - 1
if Omega["Orichalcum Gem"] < 0 then Omega["Orichalcum Gem"] = 0 end
end

--gantimite
if (gemm == "Sphalerite") or (gemm == "Tourmaline") then
Omega["Gantimite Vein Gem"] = Omega["Gantimite Vein Gem"] - 1
if Omega["Gantimite Vein Gem"] < 0 then Omega["Gantimite Vein Gem"] = 0 end
end

--karthite 
if (gemm == "Sphalerite") or (gemm == "Tourmaline") then
Omega["Karthite Vein Gem"] = Omega["Karthite Vein Gem"] - 1
if Omega["Karthite Vein Gem"] < 0 then Omega["Karthite Vein Gem"] = 0 end
end

--rhenium
if (gemm == "Sphalerite") or  (gemm == "Tourmaline") or  (gemm == "Chrysoprase") then
Omega["Rhenium Vein Gem"] = Omega["Rhenium Vein Gem"] - 1
if Omega["Rhenium Vein Gem"] < 0 then Omega["Rhenium Vein Gem"] = 0 end
end


end  --end gem remove

local function gemmADD(gemm)

--tin
if (gemm == "Sunstone") or (gemm == "Moonstone") then

Omega["Tin Lode Gem"] = Omega["Tin Lode Gem"] + 1

if Omega["Tin Lode Gem"] > 2 then Omega["Tin Lode Gem"] = 2 end
end

--copper
if (gemm == "Shimmering Opal") or (gemm =="Abyssal Opal") then
Omega["Copper Vein Gem"] = Omega["Copper Vein Gem"] + 1
if Omega["Copper Vein Gem"] > 2 then Omega["Copper Vein Gem"] = 2 end
end

--iron
if (gemm == "Celestite") or (gemm == "Heartstone") then
Omega["Iron Vein Gem"] = Omega["Iron Vein Gem"] + 1
if Omega["Iron Vein Gem"] > 2 then Omega["Iron Vein Gem"] = 2 end
end

--silver
if (gemm == "Celestite") or (gemm == "Heartstone") or (gemm == "Blood Berylite") or (gemm == "Radiant Emerald") then
Omega["Silver Vein Gem"] = Omega["Silver Vein Gem"] + 1
if Omega["Silver Vein Gem"] > 4 then Omega["Silver Vein Gem"] = 4 end
end

--chromite
if (gemm == "Blood Berylite") or (gemm =="Radiant Emerald") then
Omega["Chromite Vein Gem"] = Omega["Chromite Vein Gem"] + 1
if Omega["Chromite Vein Gem"] > 2 then Omega["Chromite Vein Gem"] = 2 end
end

--cobalt
if (gemm == "Valeglass Agate") or (gemm == "Skystone Agate") then
Omega["Cobalt Lode Gem"] = Omega["Cobalt Lode Gem"] + 1
if Omega["Cobalt Lode Gem"] > 2 then Omega["Cobalt Lode Gem"] = 2 end
end

--Gold
if (gemm == "Valeglass Agate") or (gemm == "Skystone Agate") or (gemm == "Sapphire") or (gemm == "Ruby") then
Omega["Gold Vein Gem"] = Omega["Gold Vein Gem"] + 1
if Omega["Gold Vein Gem"] > 4 then Omega["Gold Vein Gem"] = 4 end
end

--titanium
if (gemm == "Sapphire") or (gemm == "Ruby") then
Omega["Titanium Vein Gem"] = Omega["Titanium Vein Gem"] + 1
if Omega["Titanium Vein Gem"] > 2 then Omega["Titanium Vein Gem"] = 2 end
end

--carmintium
if (gemm == "Brilliant Diamond") or (gemm == "Lightsbane Diamond") then
Omega["Carmintium Deposit Gem"] = Omega["Carmintium Deposit Gem"] + 1
if Omega["Carmintium Deposit Gem"] > 2 then Omega["Carmintium Deposit Gem"] = 2 end
end

--platinum
if (gemm == "Brilliant Diamond") or (gemm == "Lightsbane Diamond") or (gemm == "Smooth Lightstone") or (gemm == "Jagged Lightstone") then
Omega["Platinum Deposit Gem"] = Omega["Platinum Deposit Gem"] + 1
if Omega["Platinum Deposit Gem"] > 4 then Omega["Platinum Deposit Gem"] = 4 end
end

--orichalcum
if (gemm == "Smooth Lightstone") or (gemm == "Jagged Lightstone") then
Omega["Orichalcum Gem"] = Omega["Orichalcum Gem"] + 1
if Omega["Orichalcum Gem"] > 2 then Omega["Orichalcum Gem"] = 2 end
end

--gantimite
if (gemm == "Sphalerite") or (gemm == "Tourmaline") then
Omega["Gantimite Vein Gem"] = Omega["Gantimite Vein Gem"] + 1
if Omega["Gantimite Vein Gem"] > 2 then Omega["Gantimite Vein Gem"] = 2 end
end

--karthite 
if (gemm == "Sphalerite") or (gemm == "Tourmaline") then
Omega["Karthite Vein Gem"] = Omega["Karthite Vein Gem"] + 1
if Omega["Karthite Vein Gem"] > 2 then Omega["Karthite Vein Gem"] = 2 end
end

--rhenium
if (gemm == "Sphalerite") or  (gemm == "Tourmaline") or  (gemm == "Chrysoprase") then
Omega["Rhenium Vein Gem"] = Omega["Rhenium Vein Gem"] + 1
if Omega["Rhenium Vein Gem"] > 3 then Omega["Rhenium Vein Gem"] = 3 end
end

end  --end gem add

local mining_gems={}
local function BuildMiningOptions(options)

local start_x = -150
local start_y = -350
local x_space = 0
local y_space = 35

local gemstart_x = 125
local gemstart_y = -350
local gemx_space = 0
local gemy_space = 35
for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.ore .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(true)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.ore .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(true)
texttest:SetFontSize(21)
texttest:SetText(material.ore)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.ore .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(true)
testcheck:SetChecked(Omega[material.node])
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(true)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()
--print(material.ore .. " Changed")

if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end
end

for key, name in pairs(material.gems) do
if mining_gems[name] == nil then mining_gems[name] = name

end end

table.insert(mining_options_frames, texturetest)
table.insert(mining_options_frames, testcheck)
table.insert(mining_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

end

for key, gemm in pairs(mining_gems) do
local gemtexturetest = UI.CreateFrame("Texture", (gemm .. "texture"), config_main_back)
gemtexturetest:SetHeight(30)
gemtexturetest:SetWidth(220)
gemtexturetest:SetLayer(6)

gemtexturetest:SetVisible(true)
gemtexturetest:SetAlpha(.3)
gemtexturetest:SetTexture("GravitationalGathering","test.png")
gemtexturetest:SetPoint("CENTER",config_main_back,"CENTER",(gemstart_x + gemx_space), (gemstart_y + gemy_space))
--text
local gemtexttest = UI.CreateFrame("Text", (gemm.. "text"), config_main_back)
gemtexttest:SetHeight(30)
gemtexttest:SetWidth(220)
gemtexttest:SetLayer(8)
gemtexttest:SetVisible(true)
gemtexttest:SetFontSize(21)
gemtexttest:SetText(gemm)
gemtexttest:SetPoint("TOPLEFT",gemtexturetest,"TOPLEFT",0,0)
gemtexttest:SetAlpha(1)

local gemtestcheck =  UI.CreateFrame("RiftCheckbox", (gemm .. "check"), config_main_back)
gemtestcheck:SetAlpha(1)
gemtestcheck:SetEnabled(true)
gemtestcheck:SetChecked(false)
gemtestcheck:SetHeight(25)
gemtestcheck:SetWidth(25)
gemtestcheck:SetLayer(8)
gemtestcheck:SetVisible(true)
gemtestcheck:SetPoint("CENTERLEFT",gemtexturetest,"CENTERRIGHT",0,0)

function gemtestcheck.Event:CheckboxChange()
if gemtestcheck:GetChecked() then
gemmADD(gemm)
else
gemmREMOVE(gemm)
end
end

table.insert(mining_options_frames, gemtexturetest)
table.insert(mining_options_frames, gemtestcheck)
table.insert(mining_options_frames, gemtexttest)

gemstart_x = gemstart_x + gemx_space
gemstart_y = gemstart_y + gemy_space
end
end

local function BuildHerbingOptions(options)
local start_x = -150
local start_y = -350
local x_space = 0
local y_space = 35

for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.herb .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(false)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.herb .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(false)
texttest:SetFontSize(21)
texttest:SetText(material.herb)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.herb .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(true)
testcheck:SetChecked(Omega[material.node])
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(false)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()

if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end
end

table.insert(herbing_options_frames, texturetest)
table.insert(herbing_options_frames, testcheck)
table.insert(herbing_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

if start_y >= 35 then

start_x = 125
start_y = -350
end
end
end

--woodoptions
local function BuildWoodingOptions(options)

local start_x = -150
local start_y = 70
local x_space = 0
local y_space = 35

for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.wood .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(false)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.wood .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(false)
texttest:SetFontSize(21)
texttest:SetText(material.wood)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.wood .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(true)
testcheck:SetChecked(Omega[material.node])
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(false)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()
--print(material.wood .. " Changed")

if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end
end

table.insert(wooding_options_frames, texturetest)
table.insert(wooding_options_frames, testcheck)
table.insert(wooding_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

if start_y >= 250 then

start_x = 125
start_y = 70

end

end

end

--art options

local function BuildArtOptions(options)

local start_x = -150
local start_y = -350
local x_space = 0
local y_space = 35

for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.node .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(false)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.node .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(false)
texttest:SetFontSize(21)
texttest:SetText(material.node)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.node .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(false)
testcheck:SetChecked(true)
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(false)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()
print(material.node .. " Changed")
--[[
if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end --]]
end

table.insert(art_options_frames, texturetest)
table.insert(art_options_frames, testcheck)
table.insert(art_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

if start_y >= 250 then

start_x = 125
start_y = 70

end

end

end


--fish
local function BuildFishOptions(options)

local start_x = -150
local start_y = -350
local x_space = 0
local y_space = 35

for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.node .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(false)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.node .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(false)
texttest:SetFontSize(21)
texttest:SetText(material.node)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.node .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(true)
testcheck:SetChecked(Omega[material.node])
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(false)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()
--print(material.node .. " Changed")

if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end
end

table.insert(fish_options_frames, texturetest)
table.insert(fish_options_frames, testcheck)
table.insert(fish_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

if start_y >= 250 then

start_x = 125
start_y = 70

end

end

end

--route
local function BuildRouteOptions(options)

local start_x = -150
local start_y = -350
local x_space = 0
local y_space = 35

for key, material in pairs(options) do

local texturetest = UI.CreateFrame("Texture", (material.node .. "texture"), config_main_back)
texturetest:SetHeight(30)
texturetest:SetWidth(220)
texturetest:SetLayer(6)

texturetest:SetVisible(false)
texturetest:SetAlpha(.3)
texturetest:SetTexture("GravitationalGathering","test.png")
texturetest:SetPoint("CENTER",config_main_back,"CENTER",(start_x + x_space), (start_y + y_space))
--text
local texttest = UI.CreateFrame("Text", (material.node .. "text"), config_main_back)
texttest:SetHeight(30)
texttest:SetWidth(220)
texttest:SetLayer(8)
texttest:SetVisible(false)
texttest:SetFontSize(21)
texttest:SetText(material.node)
texttest:SetPoint("TOPLEFT",texturetest,"TOPLEFT",0,0)
texttest:SetAlpha(1)

local testcheck =  UI.CreateFrame("RiftCheckbox", (material.node .. "check"), config_main_back)
testcheck:SetAlpha(1)
testcheck:SetEnabled(false)
testcheck:SetChecked(true)
testcheck:SetHeight(25)
testcheck:SetWidth(25)
testcheck:SetLayer(8)
testcheck:SetVisible(false)
testcheck:SetPoint("CENTERLEFT",texturetest,"CENTERRIGHT",0,0)

function testcheck.Event:CheckboxChange()
print(material.node .. " Changed")
--[[
if testcheck:GetChecked() then
Omega[material.node] = true
else
Omega[material.node] = false
end --]]
end

table.insert(route_options_frames, texturetest)
table.insert(route_options_frames, testcheck)
table.insert(route_options_frames, texttest)

start_x = start_x + x_space
start_y = start_y + y_space

if start_y >= 250 then

start_x = 125
start_y = 70

end

end

end


--BuildMiningOptions(mining_list)
--BuildHerbingOptions(herbing_list)
--BuildWoodingOptions(wooding_list)
--BuildArtOptions(artifact_list)
--BuildFishOptions(fishing_list)
--BuildRouteOptions(route_list)
local function BuildScaleOptions()



	local mapscale_slide = UI.CreateFrame("RiftSlider", "map scale", config_main_back)
	local Xscale_slide = UI.CreateFrame("RiftSlider", "X scale", config_main_back)

	local mapscale_slide_text = UI.CreateFrame("Text", "map scale text", config_main_back)
	local Xscale_slide_text = UI.CreateFrame("Text", "X scale text", config_main_back)
	
	local mapscale_slide_box = UI.CreateFrame("Text", "map scale box", config_main_back)
	local Xscale_slide_box = UI.CreateFrame("Text", "X scale box", config_main_back)

	mapscale_slide:SetRange(25,400)
	mapscale_slide:SetAlpha(1)
	mapscale_slide:SetEnabled(true)
	mapscale_slide:SetHeight(25)
	mapscale_slide:SetLayer(10)
	mapscale_slide:SetPoint("CENTER",config_main_back,"CENTER",0, -200)
	mapscale_slide:SetPosition(math.floor(GG_arrow_scale * 100))
	mapscale_slide:SetVisible(false)
	mapscale_slide:SetWidth(500)

	
	Xscale_slide:SetRange(25,400)
	Xscale_slide:SetAlpha(1)
	Xscale_slide:SetEnabled(true)
	Xscale_slide:SetHeight(25)
	Xscale_slide:SetLayer(10)
	Xscale_slide:SetPoint("CENTER",config_main_back,"CENTER",0, -100)
	Xscale_slide:SetPosition(math.floor(GG_chase_pos))
	Xscale_slide:SetVisible(false)
	Xscale_slide:SetWidth(500)

	
	mapscale_slide_text:SetAlpha(1)
	mapscale_slide_text:SetHeight(25)
	mapscale_slide_text:SetLayer(10)
	mapscale_slide_text:SetPoint("TOPLEFT",mapscale_slide,"TOPLEFT",0,-25)
	mapscale_slide_text:SetVisible(false)
	mapscale_slide_text:SetWidth(500)
	mapscale_slide_text:SetText("Adjust the slider to your current minimap scale")
	mapscale_slide_text:SetFontSize(15)
	
	Xscale_slide_text:SetAlpha(1)
	Xscale_slide_text:SetHeight(25)
	Xscale_slide_text:SetLayer(10)
	Xscale_slide_text:SetPoint("TOPLEFT",Xscale_slide,"TOPLEFT",0,-25)
	Xscale_slide_text:SetVisible(false)
	Xscale_slide_text:SetWidth(500)
	Xscale_slide_text:SetText("Adjust the slider to scale the X on the mini-map")
	Xscale_slide_text:SetFontSize(15)
	
	mapscale_slide_box:SetAlpha(1)
	mapscale_slide_box:SetHeight(30)
	mapscale_slide_box:SetLayer(10)
	mapscale_slide_box:SetPoint("CENTER",mapscale_slide,"CENTER",0,25)
	mapscale_slide_box:SetVisible(false)
	mapscale_slide_box:SetWidth(90)
	mapscale_slide_box:SetFontSize(18)
	mapscale_slide_box:SetText(tostring(GG_arrow_scale))
	
	
	Xscale_slide_box:SetAlpha(1)
	Xscale_slide_box:SetHeight(30)
	Xscale_slide_box:SetLayer(10)
	Xscale_slide_box:SetPoint("CENTER",Xscale_slide,"CENTER",0, 25)
	Xscale_slide_box:SetVisible(false)
	Xscale_slide_box:SetWidth(90)
	Xscale_slide_box:SetFontSize(18)
	Xscale_slide_box:SetText(tostring(Xscale_slide:GetPosition()).."%")

	function Xscale_slide.Event:SliderChange()
	GG_chase_scale = math.floor(36 * (Xscale_slide:GetPosition() / 100))
	GG_chase_pos = Xscale_slide:GetPosition()
	arrow:SetWidth(GG_chase_scale)
	arrow:SetHeight(GG_chase_scale)
	Xscale_slide_box:SetText(tostring(Xscale_slide:GetPosition()).."%")
	end
	
	function mapscale_slide.Event:SliderChange()
	GG_arrow_scale = mapscale_slide:GetPosition()/100.0
	mapscale_slide_box:SetText(tostring(GG_arrow_scale))
	
	end
	
	table.insert(scale_options_frames, mapscale_slide)
	table.insert(scale_options_frames, mapscale_slide_text)
	table.insert(scale_options_frames, mapscale_slide_box)
	table.insert(scale_options_frames, Xscale_slide)
	table.insert(scale_options_frames, Xscale_slide_text)
	table.insert(scale_options_frames, Xscale_slide_box)
end




local function GGsave(handle, identifier)
if identifier ~= "GravitationalGathering" then return end	 
GG_meter_x = GG.data.meter_x
GG_meter_y = GG.data.meter_y

GG_button_x = GG.data.button_x
GG_button_y = GG.data.button_y

GG_options = Omega

saved_GG_arrow_scale = GG_arrow_scale
saved_GG_arrow_adjust = GG_arrow_adjust
saved_GG_chase_scale = GG_chase_scale
saved_GG_chase_pos = GG_chase_pos

   end

local function GGload(handle, identifier)
if identifier ~= "GravitationalGathering" then return end

if GG_meter_x then
GG.data.meter_x = tonumber(GG_meter_x)
end
if GG_meter_y then
 GG.data.meter_y = tonumber(GG_meter_y)
 end
 
if GG_button_y then
GG.data.button_y = tonumber(GG_button_y)
end
if GG_button_x then
GG.data.button_x = tonumber(GG_button_x)
end
if GG_options then 
Omega = GG_options
end

if saved_GG_arrow_scale then
 GG_arrow_scale = saved_GG_arrow_scale
 end
 
if saved_GG_arrow_adjust then 
GG_arrow_adjust = saved_GG_arrow_adjust
end

if saved_GG_chase_scale then 
GG_chase_scale = saved_GG_chase_scale
arrow:SetWidth(GG_chase_scale)
arrow:SetHeight(GG_chase_scale)


end

if saved_GG_chase_pos then
GG_chase_pos = saved_GG_chase_pos
end



GGIcon:SetPoint("TOPLEFT", main, "TOPLEFT", GG.data.button_x, GG.data.button_y)
BuildMiningOptions(mining_list)
BuildHerbingOptions(herbing_list)
BuildWoodingOptions(wooding_list)
BuildArtOptions(artifact_list)
BuildFishOptions(fishing_list)
BuildRouteOptions(route_list)
BuildScaleOptions()


   end

function GG.Event.SlashHandler(handle, str)
	
	local cmd, arg = string.match(str, "(%a+) ?(.*)")
		
		arrow:SetVisible(not GG.data.update)

		GG.data.update = not GG.data.update
		GG.data.warned = true
		print("GG Toggled")
		if (GG.data.update)then
		GGIcon:SetTexture("GravitationalGathering", "GG.PNG")
		AVGticker:SetVisible(true)
		
		GG.data.warned = false
		HideMainOptions()
		createroute()
		firststamp()
		--print(table.getn(GGnodes).." Nodes Registered - Follow the red X.")
		else
		GGIcon:SetTexture("GravitationalGathering", "GGoff.PNG")
		AVGticker:SetVisible(false)
		end
		
	end   
   
    function GG_version_ping()
	if (GGPingChannelName ~= nil) then
   Command.Message.Broadcast("channel", GGPingChannelName , "GGPing", tostring(GG.data.PingVer))
	end
   Command.Message.Broadcast("guild", nil , "GGPing", tostring(GG.data.PingVer))
 
   end
   
   
   local function GGZoneChange(handle, units)
   if (GG.data.update)then
   for k, v in pairs(units) do
		if(k == Inspect.Unit.Lookup("player")) then
		
		print("Zone Changed")
		createroute()
		firststamp()
		--GG_SendAddonMessage(Inspect.Unit.Detail("player").zone, "hi")
		Command.Message.Accept(nil, "GGPing")
		GG.data.warned = false
		GG_version_ping()
		end 
		end
   else
   GG_version_ping()
   end
end
   
   local syncid = "GG1.7"
   
   --Event.Message.Receive(from, type, channel, identifier, data)
   
   function GG_Event_Message_Receive(handle, f,t,c,i,d)
   --and (f ~= Inspect.Unit.Detail("player").name)
   if (i == "GGPing") and (f ~= Inspect.Unit.Detail("player").name) then
		if (tonumber(d) > GG.data.PingVer) then
			if(GG.data.warned == false) then
				local ver = tonumber(d) /100
				print("GG version " .. ver.. " detected. Please update ASAP for the best experience.")
				GG.data.warned = true
			else 
				--print("GG detected: ".. f .. " "..d)
			end
		end
   end
   
   
   
	if i==syncid then
		--if f ~= Inspect.Unit.Detail("player").name then
			print(string.format("f=%s, t=%s, i=%s, d=%s", f,t,i,d))

			
				--end
			end
		end

   

   
   function GG_SendAddonMessage(zone, m)

	--Command.Message.Broadcast("guild", nil, syncid, m)
	--Command.Message.Broadcast("party", nil, syncid, m)
	--Command.Message.Broadcast("raid", nil, syncid, m)
	--Command.Message.Broadcast("say", nil, syncid, m)
	--Command.Message.Broadcast("yell", nil, syncid, m)
	Command.Message.Broadcast("channel", "addons", (zone..syncid), m)
end
   
   
--Command.Message.Accept("guild", syncid)
--Command.Message.Accept("channel", syncid)
Command.Message.Accept(nil, "GGPing")
--Command.Message.Accept("party", syncid)
--Command.Message.Accept("raid", syncid)
--Command.Message.Accept("say", syncid)
--Command.Message.Accept("yell", syncid)
--Command.Message.Accept("tell", syncid)
   
Command.Event.Attach(Event.Message.Receive, GG_Event_Message_Receive, "Event.Message.Receive")
Command.Event.Attach(Event.Unit.Availability.Full, GGunitAvailable, "GGunitAvailable")
Command.Event.Attach(Event.Unit.Availability.None, GGunitNotAvailable, "GGunitNotAvailable")
Command.Event.Attach(Event.Unit.Availability.Partial, GGunitNotAvailable, "GGunitNotAvailable")
Command.Event.Attach(Event.Unit.Detail.Zone, GGZoneChange, "GGZoneChange")   
Command.Event.Attach(Event.System.Update.Begin, run_job, "run_job")
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, GGsave, "Save variables")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, GGload,  "Load variables")
Command.Event.Attach(Event.Addon.Load.End, GG.Event.LoadEnd, "Init")
Command.Event.Attach(Command.Slash.Register("GG"), GG.Event.SlashHandler, "Slash")






